package com.jmgv.themerchant;

import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import com.example.themerchant.R;
import com.google.gson.JsonParseException;
import com.jmgv.ui.CustomButton;
import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Scroller;
import android.widget.TextView;
import android.widget.Toast;

public class CaptainActivity extends Activity {

	public static final String TAG_LOGIN="login";
	public static final String TAG_TRIPULACION= "id_tripulacion";
	public static final String TAG_NOMBRE = "nombre";
	public static final String TAG_NAVEGACION= "navegacion";
	public static final String TAG_PILOTAJE= "pilotaje";
	public static final String TAG_ARTILLERIA = "artilleria";
	public static final String TAG_INGENIERIA= "ingenieria";
	public static final String TAG_COMBATE= "combate";
	public static final String TAG_FUNCION= "funcion";
	public static final String TAG_COSTE= "coste";
	public static final String TAG_ID_NAVE= "id_nave";
	public static final String TAG_BIOGRAFIA= "biografia";

	JSONArray troops = null;
	ArrayList<HashMap<String, String>> troopList;
	ListView listTroop;
	JSONParser jsonParser = new JSONParser();
	BaseAdapter mAdapter;
	
	String nombre="";
	String id_tripulacion;
	String id_crew;
	String biography="";
	
	CustomButton btnNavigate; 
	TextView txtBiography;
	ImageView imgCaptain;
	ImageView imgCrew;
	
	Bitmap bmpCaptain;
	Bitmap bmpCrew;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		try {
			super.onCreate(savedInstanceState);
			setContentView(R.layout.activity_captain );
			
			this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
			    
			
			txtBiography =(TextView) findViewById(R.id.txtBiography);
			txtBiography.setScroller(new Scroller(getBaseContext())); 
			//txtBiography.setMaxLines(1); 
			txtBiography.setVerticalScrollBarEnabled(true); 
			txtBiography.setMovementMethod(new ScrollingMovementMethod()); 
			
			
			
			imgCaptain = (ImageView) findViewById (R.id.imgModule);
			imgCrew=(ImageView) findViewById (R.id.imgCrew);
			
			
			CustomButton btnHome = (CustomButton) findViewById(R.id.btnMainHome);
	    	btnHome.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                      finish();
	                    }
	            });     
	    	
	    	troopList = new ArrayList<HashMap<String, String>>();
			
	    	listTroop = (ListView) findViewById(R.id.lstCrew);
			listTroop.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
				@Override
				public void onItemClick(AdapterView<?> arg0, View view,
						int position, long arg3) {
					
					try 
					{
						id_crew = ((TextView) view.findViewById(R.id.txtCrewId )).getText().toString();
						LoadTroop loadTroopCaptain=new LoadTroop();
						loadTroopCaptain.execute("CREW",id_crew);
					}
					catch (Exception ex)
					{
						ex.printStackTrace();
					}
				}
			});
	    	
			LoadTroop loadTroop=new LoadTroop();
			loadTroop.execute();
			
			LoadTroop loadTroopCaptain=new LoadTroop();
			loadTroopCaptain.execute("CAPTAIN");
			
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	class LoadTroop extends AsyncTask<String, String, String> {
		String accion="";		
	    Context context;
	    
	  
	    
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		
			/*
			pDialog = new ProgressDialog(SocialActivity.this);
			pDialog.setMessage( getResources().getString(R.string.getting_friends ));
			pDialog.setIndeterminate(false);
			pDialog.setCancelable(false);
			pDialog.show();
			*/
		
		}

		@Override
		protected String doInBackground(String... args) {

			String json = ""; 
			
			if (args.length>0)
	    	{
		    	
				
				try
		        {
					//Construimos el objeto cliente en formato JSON
					String respStr="";
					accion=args[0].toString();
					HttpClient httpClient = new DefaultHttpClient();
					if (accion.equals("ASIGNA")) {
						HttpPut put = new HttpPut(Session.URL + "tripulacion/tripulacion" );
						put.setHeader("content-type", "application/json");
					
						JSONObject dato = new JSONObject();
						dato.put("login", args[1]);
						dato.put("id_tripulacion", Double.parseDouble(args[2]));
						
						StringEntity entity = new StringEntity(dato.toString());
						put.setEntity(entity);
						
			        	HttpResponse resp = httpClient.execute(put);
			        	respStr = EntityUtils.toString(resp.getEntity());
					}
					else if (accion.equals("CAPTAIN")) {
						HttpGet del = new HttpGet(Session.URL + "capitan/capitan/" + Session.login);
						
						del.setHeader("content-type", "application/json");
							
				        	HttpResponse resp = httpClient.execute(del);
				        	respStr = EntityUtils.toString(resp.getEntity());
				        	
				        	JSONObject respJSON = new JSONObject(respStr);
				        	
				        	
				        	nombre= respJSON.getString(TAG_NOMBRE);
				        	id_tripulacion=respJSON.getString(TAG_TRIPULACION);
				        	biography=respJSON.getString(TAG_BIOGRAFIA);
				        	
				        	URL url = new URL(Session.URL+ "img/captain/" + String.valueOf(id_tripulacion) + ".jpg");
				        	
				        	bmpCaptain = BitmapFactory.decodeStream(url.openConnection().getInputStream());
				        	json="OK";
						
				        	
					}
					else if (accion.equals("CREW")) {
						HttpGet del = new HttpGet(Session.URL + "capitan/capitan/" + args[1]);
						
						del.setHeader("content-type", "application/json");
							
				        	HttpResponse resp = httpClient.execute(del);
				        	respStr = EntityUtils.toString(resp.getEntity());
				        	
				        	JSONObject respJSON = new JSONObject(respStr);
				        	
				        	id_crew=args[1];
				        	URL url = new URL(Session.URL+ "img/captain/" + String.valueOf(id_crew) + ".jpg");
				        	bmpCrew= BitmapFactory.decodeStream(url.openConnection().getInputStream());
				        	
				        	json="OK";
						   	
					}
					else
					{
						HttpDelete del = new HttpDelete(Session.URL + "tripulacion/tripulacion" );
						del.setHeader("content-type", "application/json");
					
						del.setHeader("id",args[2]);
						
			        	HttpResponse resp = httpClient.execute(del);
			        	 respStr = EntityUtils.toString(resp.getEntity());
			        

				        	if(!respStr.equals("true"))
				        		json ="KO";
				        	else
				        		json = "OK";
					}
		        }
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	
		        	json = "KO";
		        }
				
	    	}
			else {
				List<NameValuePair> params = new ArrayList<NameValuePair>();
	
				// getting JSON string from URL
				json = jsonParser.makeHttpRequest(Session.URL + "tripulacion/tripulaciones/" + Session.login, "GET",
						params);
	
				// Check your log cat for JSON reponse
				Log.d("Mails JSON: ", "> " + json);
			}
			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				if (json!="OK" && json!="KO")
				{
					troops = new JSONArray(json);
					troopList.clear();
					if (troops != null) {
						// looping through All albums
						for (int i = 0; i < troops.length(); i++) {
							JSONObject c = troops.getJSONObject(i);
	
							// Storing each json item values in variable
							
							
							// creating new HashMap
							HashMap<String, String> map = new HashMap<String, String>();
						
							map.put(TAG_LOGIN,c.getString(TAG_LOGIN).toString());
							map.put(TAG_TRIPULACION,String.valueOf((int)c.getDouble(TAG_TRIPULACION)));
							map.put(TAG_NOMBRE,c.getString(TAG_NOMBRE));							
							map.put(TAG_NAVEGACION ,String.valueOf((int)c.getDouble(TAG_NAVEGACION)));
							map.put(TAG_PILOTAJE ,String.valueOf((int)c.getDouble(TAG_PILOTAJE)));
							map.put(TAG_ARTILLERIA ,String.valueOf((int)c.getDouble(TAG_ARTILLERIA)));
							map.put(TAG_INGENIERIA ,String.valueOf((int)c.getDouble(TAG_INGENIERIA)));
							map.put(TAG_COMBATE ,String.valueOf((int)c.getDouble(TAG_COMBATE)));
							map.put(TAG_FUNCION ,c.getString(TAG_FUNCION));
							map.put(TAG_COSTE ,String.valueOf((int)c.getDouble(TAG_COSTE)));
							map.put(TAG_ID_NAVE ,String.valueOf((int)c.getDouble(TAG_ID_NAVE)));
							map.put(TAG_BIOGRAFIA ,c.getString(TAG_BIOGRAFIA));
				
							
							// adding HashList to ArrayList
							troopList.add(map);
						}
	
						mAdapter = new CrewListAdapter(CaptainActivity.this,
								troopList);
						listTroop.setAdapter(mAdapter);
						mAdapter.notifyDataSetChanged();
						
						// dismiss the dialog after getting all albums
						//pDialog.dismiss();
					} else {
						Log.d("Planets: ", "null");
					}
	
				} else 
				{
					if (json.equals("OK")) { 
						if (accion.equals("CAPTAIN")) {
							imgCaptain.setImageBitmap(bmpCaptain);
							txtBiography.setText(biography);
						}
						else if (accion.equals("CREW")) {
							imgCrew.setImageBitmap(bmpCrew);
							
						}
					}
					else
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.troop_error) , 
		        			   Toast.LENGTH_LONG).show();
					}
				}
			} catch (JSONException e) {
				e.printStackTrace();
				
			} catch (JsonParseException e) {
				e.printStackTrace();
				
			}
			
		}
	}

}