package com.jmgv.themerchant;
 
import android.app.IntentService;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.SystemClock;
import android.support.v4.app.NotificationCompat;
import android.util.Log;
 
import com.google.android.gms.gcm.GoogleCloudMessaging;
 
public class GCMNotificationIntentService extends IntentService {
 
  public static final int NOTIFICATION_ID = 1;
  private NotificationManager mNotificationManager;
  NotificationCompat.Builder builder;
 
  public GCMNotificationIntentService() {
    super("GcmIntentService");
  }
 
  public static final String TAG = "GCMNotificationIntentService";
 
  @Override
  protected void onHandleIntent(Intent intent) {
    Bundle extras = intent.getExtras();
    GoogleCloudMessaging gcm = GoogleCloudMessaging.getInstance(this);
 
    String messageType = gcm.getMessageType(intent);
 
    if (!extras.isEmpty()) {
      if (GoogleCloudMessaging.MESSAGE_TYPE_SEND_ERROR
          .equals(messageType)) {
        sendNotification("Send error: " + extras.toString());
      } else if (GoogleCloudMessaging.MESSAGE_TYPE_DELETED
          .equals(messageType)) {
        sendNotification("Deleted messages on server: "
            + extras.toString());
      } else if (GoogleCloudMessaging.MESSAGE_TYPE_MESSAGE
          .equals(messageType)) {
 
        for (int i = 0; i < 3; i++) {
          Log.i(TAG,
              "Working... " + (i + 1) + "/5 @ "
                  + SystemClock.elapsedRealtime());
          try {
            Thread.sleep(5000);
          } catch (InterruptedException e) {
          }
 
        }
        Log.i(TAG, "Completed work @ " + SystemClock.elapsedRealtime());
 
        sendNotification("Message Received from Google GCM Server: "
            + extras.get("message"));
        
	        String mensaje = (String) extras.get ("message");
	  	   if (mensaje.equals("CHAT")) {
	  		   Session.blnChat=true;
	  	   } else if (mensaje.equals("MAIL")) {
	  		   Session.blnMail=true;
	  	   } else if (mensaje.equals("TRAVEL")) {
	  		   Session.blnNavigating=true;
	  	   } 
	

        Log.i(TAG, "Received: " + extras.toString());
      }
    }
    GcmBroadcastReceiver.completeWakefulIntent(intent);
  }
 
  private void sendNotification(String msg) {
   
  }
}