package com.jmgv.themerchant;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONObject;

import com.example.themerchant.R;
import com.jmgv.ui.CustomButton;
import com.jmgv.ui.CustomTextView;

import android.app.Activity;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.EditText;



public class LoginActivity extends Activity {

	private EditText txtPassword;
	private EditText txtLogin;
	private CustomTextView ctvResultado;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_login);
		setControls(); 
		this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
		
			
    }
	
    public void setControls() {
    	
    	txtPassword = (EditText) findViewById(R.id.etPasswordLG);
    	txtLogin = (EditText) findViewById(R.id.etLoginLG);
    	ctvResultado =(CustomTextView) findViewById(R.id.ctvResultado);
    	
    	CustomButton btnHome = (CustomButton) findViewById(R.id.btnHome);
    	btnHome.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View arg0) {
                      finish();
                    }
            });     
    	
    	CustomButton btnPlay = (CustomButton) findViewById(R.id.btnPlay);
    	btnPlay.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View arg0) {
                    	
                    	TareaLogin tarea = new TareaLogin();
        				tarea.execute(txtLogin.getText().toString());
                    	
                    }
            });     
	}

//Tarea As?ncrona para llamar al WS de consulta en segundo plano
class TareaLogin extends AsyncTask<String,Integer,Boolean> {
	
	private String password;
	 
    protected Boolean doInBackground(String... params) {
    	
    	Boolean validado=false; 
    	HttpClient httpClient = new DefaultHttpClient();        
		String id = params[0];
		
		//HttpGet del = new HttpGet("http://10.0.2.2:8080/Usuarios/Usuario/" + id);
		
		HttpGet del = new HttpGet(Session.URL + "Usuarios/Usuario/" + id);
		
		del.setHeader("content-type", "application/json");
		
		try
        {			
        	HttpResponse resp = httpClient.execute(del);
        	String respStr = EntityUtils.toString(resp.getEntity());
        	
        	JSONObject respJSON = new JSONObject(respStr);
        	
        	
        	respJSON.getString("Login");
        	password = respJSON.getString("Password");
        	validado=(password.equals(txtPassword.getText().toString()));
        	
        }
        catch(Exception ex)
        {
        	Log.e("ServicioRest","Error!", ex);
        	validado = false;
        }
 
        return validado;
    }
    
    protected void onPostExecute(Boolean result) {
    	
    	if (result)
    	{
    		Session.login= txtLogin.getText().toString();
    		ctvResultado.setText("");
    		Intent MenuIntent = 
                    new Intent(getBaseContext(), MenuActivity.class);
                    startActivity(MenuIntent);
                    finish();
    	}
    	else
    	{
    		ctvResultado.setText(getResources().getString(R.string.error_login));
    	}
    }
}

}
