package com.jmgv.themerchant;

import java.io.IOException;
import java.net.URL;
import java.util.Timer;
import java.util.TimerTask;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONObject;

import com.example.themerchant.R;
import com.google.android.gms.gcm.GoogleCloudMessaging;
import com.jmgv.ui.CustomButton;
import com.jmgv.ui.CustomTextView;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.Toast;

public class MenuActivity extends Activity {
	CustomTextView btnGemm; 
	CustomButton btnMoney;
	CustomTextView  btnEscudo;
	CustomTextView  btnArmadura;
	CustomTextView  btnLocation;
	CustomTextView  btnETA;
	
	ImageView imgPlanet;
	ImageView imgShip;
	

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		try {
			
			setContentView(R.layout.activity_menu);
			setClicks();
			estableceSaldos();
			TareaRegistraGCM TR=new  TareaRegistraGCM();
			TR.execute(Session.login, Session.RegID);
			callAsynchronousTaskChat();
			
		} catch (UnsupportedOperationException e) {
			   Log.e("TM", "El dispositivo no soporta GCM.", e);
		} catch (IllegalStateException e) {
		   Log.e("TM", "El manifest no est bien configurado.", e);
		}
    }
	
	 public void setClicks() {
		 	
		 	btnMoney=(CustomButton) findViewById(R.id.cbtMoney);
		 	btnEscudo=(CustomTextView ) findViewById(R.id.ctbEscudo);
		 	btnArmadura=(CustomTextView ) findViewById(R.id.ctbArmadura);
		 	btnLocation=(CustomTextView ) findViewById(R.id.ctbLocation);
		 	btnETA= (CustomTextView ) findViewById(R.id.cbtETA);
		 	
		 	imgPlanet=(ImageView) findViewById(R.id.imgPlaneta);
		 	imgShip=(ImageView) findViewById(R.id.imgNave);
		 	
		 	btnGemm=(CustomTextView) findViewById(R.id.cbtGemm);
		 	btnGemm.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View arg0) {
                 try { 
                	 Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.menu_future_function) , 
		        			   Toast.LENGTH_LONG).show();

                }
		        catch(Exception ex)
		        {
		        	Log.e("Lanzamiento Social","Error!", ex);
		        }
                }
		 		});  
		 	
		 	CustomButton btnNavigate = (CustomButton) findViewById(R.id.cbtNavigation);
		 	btnNavigate.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                     try { 
	                    	Intent navigateIntent = 
	                        new Intent(getBaseContext(),  NavigateActivity.class);
	                        startActivity(navigateIntent);
	                        
	                    }
	    		        catch(Exception ex)
	    		        {
	    		        	Log.e("Lanzamiento Social","Error!", ex);
	    		        }
	                    }
	            });  
	    	
		 	
		 	CustomButton btnShip = (CustomButton) findViewById(R.id.cbtShip);
		 	btnShip.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                     try { 
	                    	Intent shipIntent = 
	                        new Intent(getBaseContext(),  ShipActivity.class);
	                        startActivity(shipIntent);
	                    }
	    		        catch(Exception ex)
	    		        {
	    		        	Log.e("Lanzamiento Social","Error!", ex);
	    		        }
	                    }
	            });  
	    	
	    	CustomButton btnTrade = (CustomButton) findViewById(R.id.cbtTrade );
	    	btnTrade.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                     try { 
	                    	Intent tradeIntent = 
	                        new Intent(getBaseContext(),  TradeActivity.class);
	                        startActivity(tradeIntent);
	                    }
	    		        catch(Exception ex)
	    		        {
	    		        	Log.e("Lanzamiento Social","Error!", ex);
	    		        }
	                    }
	            });  
	    	
	    	CustomButton btnCaptain = (CustomButton) findViewById(R.id.cbtCaptain );
	    	btnCaptain.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                     try { 
	                    	Intent captainIntent = 
	                        new Intent(getBaseContext(),  CaptainActivity.class);
	                        startActivity(captainIntent);
	                    }
	    		        catch(Exception ex)
	    		        {
	    		        	Log.e("Lanzamiento Social","Error!", ex);
	    		        }
	                    }
	            });  
		 	
		 	CustomButton btnSocial = (CustomButton) findViewById(R.id.cbtSocial);
	    	btnSocial.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                     try { 
	                    	Intent socialIntent = 
	                        new Intent(getBaseContext(),  SocialActivity.class);
	                        startActivity(socialIntent);
	                    }
	    		        catch(Exception ex)
	    		        {
	    		        	Log.e("Lanzamiento Social","Error!", ex);
	    		        }
	                    }
	            });  
	    	
		}
	 
	 
		public void callAsynchronousTaskChat() {
		    final Handler handler = new Handler();
		    Timer timer = new Timer();
		    TimerTask doAsynchronousTask = new TimerTask() {       
		        @Override
		        public void run() {
		            handler.post(new Runnable() {
		                public void run() {       
		                    try {
		                    	//if (Session.blnNavigating) { 
		                    		estableceSaldos();
		                    	//}
		                    } catch (Exception e) {
		                        e.printStackTrace();
		                    }
		                }
		            });
		        }
		    };
		    timer.schedule(doAsynchronousTask, 0, 5000); //execute in every 50000 ms
		}

	 
	 public void estableceSaldos(){
		try
		{
			
			TareaInfo tarea = new TareaInfo();
			tarea.execute();
		
		}
		 catch(Exception ex)
	        {
	        	Log.e("ServicioRest","Error!", ex);
	        }

	 }
	 
	 class TareaInfo extends AsyncTask<String,Integer,Boolean> {
		 	private double idPrevio=-1;
			private String gemas;
			private String saldo;
			private String armadura;
			private String escudo;
			private String location;
			private String destino;
			private String distancia;
			private Bitmap bmpShip;
        	private Bitmap bmpPlanet;
			 
		    protected Boolean doInBackground(String... params) {
		    	
		    	Boolean validado=false; 
		    	HttpClient httpClient = new DefaultHttpClient();        
				String id = Session.login;
				
				HttpGet del = new HttpGet(Session.URL + "Usuarios/Usuario/" + id);
				
				del.setHeader("content-type", "application/json");
				
				try
		        {			
		        	HttpResponse resp = httpClient.execute(del);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	
		        	JSONObject respJSON = new JSONObject(respStr);
		        	
		        	
		        	respJSON.getString("Login");
		        	gemas = String.valueOf((int)respJSON.getDouble("gemas"));
		        	saldo = String.valueOf((int)respJSON.getDouble("saldo")).concat( " ");
		        	armadura = "Hull: ".concat(String.valueOf((int)respJSON.getDouble("armadura")));
		        	escudo = "Armor: ".concat(String.valueOf((int)respJSON.getDouble("escudos")));
		        	location = "Location: ".concat(respJSON.getString("planeta_origen"));
		        	destino=respJSON.getString("planeta_destino");
		        	distancia=respJSON.getString("distancia");
		        	if (Integer.parseInt(distancia)>0)
		        	{
		        		destino=distancia.concat(" ly to ").concat(destino);
		        	}
		        	else {
		        		destino="";
		        	}
			        	//if (String.valueOf(idPrevio).equals(String.valueOf((int)respJSON.getDouble("nave")))) {
			        	URL url = new URL(Session.URL+ "img/ship/" + String.valueOf((int)respJSON.getDouble("nave")) + ".jpg");
			        	bmpShip = BitmapFactory.decodeStream(url.openConnection().getInputStream());
			        	
			        	
			        	url = new URL(Session.URL+ "img/planet/" + String.valueOf((int) respJSON.getDouble("origen")) + ".jpg");
			        	bmpPlanet = BitmapFactory.decodeStream(url.openConnection().getInputStream());
			        
			        	idPrevio=respJSON.getDouble("nave");	
			        //}
		        	validado=true;
		        	
		        }
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	validado = false;
		        }
		 
		        return validado;
		    }
		    
		    protected void onPostExecute(Boolean result) {
		    	try
		    	{
		    		
			    	if (result)
			    	{
			    		gemas= gemas.concat( " gems");
			    		saldo = saldo.concat(" $");
			    		btnGemm.setText((String)getResources().getString(R.string.menu_get_gemms));
			    		btnMoney.setText(saldo );
			    		btnArmadura.setText(armadura);
			    		btnEscudo.setText(escudo);
			    		btnLocation.setText(location);
			    		btnETA.setText(destino);
			    		
			    	 	imgShip.setImageBitmap(bmpShip);
			        	imgPlanet.setImageBitmap(bmpPlanet);
			        	
			    	}
			    	else
			    	{
			    		btnGemm.setText("0 gems");
			    		btnMoney.setText( "0 $");
			    	}

		    	}
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	
		        }

		    }
		}

	 
	 private class TareaRegistraGCM extends AsyncTask<String,Integer,Boolean> {
			
		    protected Boolean doInBackground(String... params) {
		    	
		    	boolean resul = true;
		    	

				try
		        {
						String respStr="";
						HttpClient httpClient = new DefaultHttpClient();
						HttpPut put = new HttpPut(Session.URL + "Usuarios/Usuario");

						put.setHeader("content-type", "application/json");
					
						JSONObject dato = new JSONObject();
						dato.put("login", Session.login);
						dato.put("RegID", Session.RegID);
						
						StringEntity entity = new StringEntity(dato.toString());
						put.setEntity(entity);
						
			        	HttpResponse resp = httpClient.execute(put);
			        	respStr = EntityUtils.toString(resp.getEntity());

			        	resul = true;
			        }
			        catch(Exception ex)
			        {
			        	Log.e("ServicioRest","Error!", ex);
			        	resul = false;
			        }
		    	
		        return resul;
		    }
		    
		    protected void onPostExecute(Boolean result) {
		    	
		    	if (result)
		    	{
		    		//Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.registered_GCM) ,
		        	//		   Toast.LENGTH_LONG).show();
		    		
		    	}
		    	else
		    	{
		    		Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.not_registered_GCM) , 
		        			   Toast.LENGTH_LONG).show();
		    	}

		    }	    
		}
	 
	}