package com.jmgv.themerchant;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import com.example.themerchant.R;
import com.google.gson.JsonParseException;
import com.jmgv.ui.CustomButton;import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;


public class NavigateActivity extends Activity {
	
	public static final String TAG_LOGIN="login";
	public static final String TAG_PLANET = "planeta_destino";
	public static final String TAG_PLANET_ID = "id_planeta";
	public static final String TAG_DIST = "distancia";
	public static final String TAG_CLIMA = "clima";
	public static final String TAG_REL = "religion";
	public static final String TAG_EST = "estabilidad";
	public static final String TAG_TECH = "tech";
	public static final String TAG_GOV = "gobierno";

	JSONArray planets = null;
	ArrayList<HashMap<String, String>> planetsList;
	ListView listPlanets;
	JSONParser jsonParser = new JSONParser();
	BaseAdapter mAdapter;
	
	String planetTarget="";
	String planetTargetId="";
	String distancia="0";
	CustomButton btnNavigate; 
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		try {
			super.onCreate(savedInstanceState);
			setContentView(R.layout.activity_navigate);
			
			this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
			

			btnNavigate = (CustomButton) findViewById(R.id.cbtNavigate );
			btnNavigate.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                    	if (planetTarget!="") {
	                    	new LoadPlanets().execute(Session.login,planetTargetId,distancia);
	                    	
	                    }
	                }
	            });     
	    
			
			CustomButton btnHome = (CustomButton) findViewById(R.id.btnMainHome);
	    	btnHome.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                      finish();
	                    }
	            });     
	    	
	    	planetsList = new ArrayList<HashMap<String, String>>();
			
	    	listPlanets = (ListView) findViewById(R.id.lstPlanet);
			listPlanets.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
				@Override
				public void onItemClick(AdapterView<?> arg0, View view,
						int position, long arg3) {
					
					try {
						
						planetTarget = (String) ((TextView) view.findViewById(R.id.txtPlanet )).getText().toString();
						planetTargetId = (String) ((TextView) view.findViewById(R.id.txtPlanetId )).getText().toString();
						distancia=(String) ((TextView) view.findViewById(R.id.txtDist)).getText().toString();
						btnNavigate.setText(getResources().getString(R.string.navigation) + " to " + planetTarget );
					}
					catch (Exception ex)
					{
						ex.printStackTrace();
					}
				}
			});
	    	
			new LoadPlanets().execute();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	class LoadPlanets extends AsyncTask<String, String, String> {
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		}

		@Override
		protected String doInBackground(String... args) {

			String json; 
			if (args.length>0)
	    	{
		    	HttpClient httpClient = new DefaultHttpClient();
		        
				HttpPut put = new HttpPut(Session.URL + "planetas/planeta");
				put.setHeader("content-type", "application/json");
				
				try
		        {
					//Construimos el objeto cliente en formato JSON
					JSONObject dato = new JSONObject();
					
					dato.put("login", args[0]);
					dato.put("id_planeta", Double.parseDouble(args[1]));
					dato.put("distancia", Double.parseDouble(args[2]));
					
					StringEntity entity = new StringEntity(dato.toString());
					put.setEntity(entity);
					
		        	HttpResponse resp = httpClient.execute(put);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	
		        	if(!respStr.equals("true"))
		        		json ="KO";
		        	else
		        		json = "OK";
		        	

		        }
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	
		        	json = "KO";
		        }
				
	    	}
			else {
				List<NameValuePair> params = new ArrayList<NameValuePair>();
	
				// getting JSON string from URL
				json = jsonParser.makeHttpRequest(Session.URL + "planetas/planetas/" + Session.login, "GET",
						params);
	
				// Check your log cat for JSON reponse
				Log.d("Mails JSON: ", "> " + json);
			}
			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				if (json!="OK" && json!="KO")
				{
					planets = new JSONArray(json);
					planetsList.clear();
					if (planets != null) {
						// looping through All albums
						for (int i = 0; i < planets.length(); i++) {
							JSONObject c = planets.getJSONObject(i);
	
							// Storing each json item values in variable
							
							
							// creating new HashMap
							HashMap<String, String> map = new HashMap<String, String>();


							
							map.put(TAG_LOGIN,c.getString(TAG_LOGIN).toString());
							map.put(TAG_PLANET,c.getString(TAG_PLANET));
							map.put(TAG_PLANET_ID,String.valueOf((int)c.getDouble(TAG_PLANET_ID)));							
							map.put(TAG_DIST ,String.valueOf((int)c.getDouble(TAG_DIST)));
							map.put(TAG_CLIMA ,c.getString(TAG_CLIMA));
							map.put(TAG_REL ,c.getString(TAG_REL));
							map.put( TAG_EST ,String.valueOf((int)c.getDouble(TAG_EST)));
							map.put(TAG_TECH ,String.valueOf((int)c.getDouble(TAG_TECH)));
							map.put( TAG_GOV ,c.getString(TAG_GOV));
							
							
							// adding HashList to ArrayList
							planetsList.add(map);
						}
	
						mAdapter = new PlanetListAdapter(NavigateActivity.this,
								planetsList);
						listPlanets.setAdapter(mAdapter);
						mAdapter.notifyDataSetChanged();
						
						// dismiss the dialog after getting all albums
						//pDialog.dismiss();
					} else {
						Log.d("Planets: ", "null");
					}
	
				} else 
				{
					if (json.equals("OK")) { 
						Session.blnNavigating=true;
						finish();
					}
					else
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.planet_error) , 
		        			   Toast.LENGTH_LONG).show();
					}
				}
			} catch (JSONException e) {
				e.printStackTrace();
				
			} catch (JsonParseException e) {
				e.printStackTrace();
				
			}
		}
	}

}