package com.jmgv.themerchant;


import java.util.ArrayList;
import java.util.HashMap;

import com.example.themerchant.R;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class PlanetListAdapter extends BaseAdapter {
	private Boolean hide=false;
	private Context mContext;
	LayoutInflater inflater;
	private final ArrayList<HashMap<String, String>> urls;
	HashMap<String, String> resultp = new HashMap<String, String>();
	
	
	public PlanetListAdapter(Context context,
			ArrayList<HashMap<String, String>> items) {
		mContext = context;
		urls = items;
	}

	public PlanetListAdapter(Context context,
			ArrayList<HashMap<String, String>> items, boolean hideColumns) {
		mContext = context;
		urls = items;
		hide=hideColumns;
	}
	
    public int getCount() {
        return urls.size();
    }
 
    public Object getItem(int position) {
        return position;
    }

	@Override
	public long getItemId(int position) {
		return getItem(position).hashCode();
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View view=null;
		try{
			
		inflater = (LayoutInflater) mContext
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

		view = inflater.inflate(R.layout.custom_list_planets_complete , parent,
				false);

		resultp = urls.get(position);
		

		TextView nav_planet= (TextView) view.findViewById(R.id.txtPlanet );
		TextView nav_planet_id= (TextView) view.findViewById(R.id.txtPlanetId );
		TextView nav_dist = (TextView) view.findViewById(R.id.txtDist  );
		TextView nav_clima = (TextView) view.findViewById(R.id.txtClima );
		TextView nav_rel= (TextView) view.findViewById(R.id.txtRel );
		TextView nav_est= (TextView) view.findViewById(R.id.txtEst );
		TextView nav_tech= (TextView) view.findViewById(R.id.txtTech );
		TextView nav_gov= (TextView) view.findViewById(R.id.txtGov );

		
		if (hide) {
			nav_rel.setVisibility(View.GONE);
			nav_gov.setVisibility(View.GONE);
			TextView nav_title_rel= (TextView) view.findViewById(R.id.txtRelTitle);
			TextView nav_title_gov= (TextView) view.findViewById(R.id.txtGovTitle);
			nav_title_rel.setVisibility(View.GONE);
			nav_title_gov.setVisibility(View.GONE);
		}
		
		nav_planet.setText(resultp.get(NavigateActivity.TAG_PLANET));
		nav_planet_id.setText(resultp.get(NavigateActivity.TAG_PLANET_ID));
		nav_dist.setText(resultp.get(NavigateActivity.TAG_DIST));
		nav_clima.setText(resultp.get(NavigateActivity.TAG_CLIMA));
		nav_rel.setText(resultp.get(NavigateActivity.TAG_REL));
		nav_est.setText(resultp.get(NavigateActivity.TAG_EST));
		nav_tech.setText(resultp.get(NavigateActivity.TAG_TECH));
		nav_gov.setText(resultp.get(NavigateActivity.TAG_GOV));
		
		
		} catch (Exception ex ){
			ex.printStackTrace();
		}
		return view;
	}
}