package com.jmgv.themerchant;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONObject;

import com.example.themerchant.R;
import com.jmgv.ui.CustomButton;
import com.jmgv.ui.CustomTextView;

import android.app.Activity;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.EditText;

public class RegisterActivity extends Activity {

	private EditText txtPassword;
	private EditText txtConfirmaPassword;
	private EditText txtLogin;
	private EditText txtEmail;
	private CustomTextView ctvResultado;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_register);
		 setControls(); 
    }
	
    public void setControls() {
    	
    	txtPassword = (EditText) findViewById(R.id.etPassword);
    	txtConfirmaPassword = (EditText) findViewById(R.id.etConfirmaPassword);
    	txtLogin = (EditText) findViewById(R.id.etUser);
    	txtEmail = (EditText) findViewById(R.id.etMail);
    	ctvResultado =(CustomTextView) findViewById(R.id.ctvResultado);
    	
    	this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
		
    	
    	CustomButton btnHome = (CustomButton) findViewById(R.id.btnHomeRegister);
    	btnHome.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View arg0) {
                      finish();
                    }
            });     
    	
    	CustomButton btnPlay = (CustomButton) findViewById(R.id.btnPlayRegister);
    	btnPlay.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View arg0) {

                    	TareaRegistrar tarea = new TareaRegistrar();
        				tarea.execute(txtLogin.getText().toString(),txtPassword.getText().toString(),txtConfirmaPassword.getText().toString(), txtEmail.getText().toString());
                    }
            });     
	}

private class TareaRegistrar extends AsyncTask<String,Integer,Boolean> {
		
	    protected Boolean doInBackground(String... params) {
	    	
	    	boolean resul = true;
	    	
	    	
	    	if (params[1].toString().equals(params[2].toString()))
	    	{
		    	HttpClient httpClient = new DefaultHttpClient();
		        
				HttpPost post = new HttpPost(Session.URL + "Usuarios/Usuario");
				post.setHeader("content-type", "application/json");
				
				try
		        {
					//Construimos el objeto cliente en formato JSON
					JSONObject dato = new JSONObject();
					
					//dato.put("Id", Integer.parseInt(txtId.getText().toString()));
					dato.put("Login", params[0]);
					dato.put("Password", params[1]);
					dato.put("Email", params[3]);
					
					StringEntity entity = new StringEntity(dato.toString());
					post.setEntity(entity);
					
		        	HttpResponse resp = httpClient.execute(post);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	
		        	//if(!respStr.equals("true"))
		        	//	resul = false;
		        	resul = true;
		        }
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	resul = false;
		        }
	    	}
	    	else
	    	{
	    		resul =false;
	    	}
	    	
	        return resul;
	    }
	    
	    protected void onPostExecute(Boolean result) {
	    	
	    	if (result)
	    	{

	    		Session.login= txtLogin.getText().toString();
	    		ctvResultado.setText("");
	    		Intent MenuIntent = 
                        new Intent(getBaseContext(), MenuActivity.class);
                        startActivity(MenuIntent);
                        finish();
	    	}
	    	else
	    	{
	    		ctvResultado.setText(getResources().getString(R.string.error_creating_user));
	    	}
	    }	    
	}

}