package com.jmgv.themerchant;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.example.themerchant.R;
import com.google.gson.JsonParseException;
import com.jmgv.ui.CustomButton;
import com.jmgv.ui.CustomTextView;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class ShipActivity extends Activity {
	public static final String TAG_MODULE_LOGIN = "login";
	public static final String TAG_MODULE_ID_NAVE = "id_nave";
	public static final String TAG_MODULE_ID_MODULO = "id_modulo";
	public static final String TAG_MODULE_NOMBRE = "nombre";
	public static final String TAG_MODULE_DESCRIPCION = "descripcion";
	public static final String TAG_MODULE_TRIPULACION = "tripulacion";
	public static final String TAG_MODULE_TECH = "tech";
	public static final String TAG_MODULE_CARGA = "carga";
	public static final String TAG_MODULE_MOTOR = "motor";
	public static final String TAG_MODULE_ARMADURA = "armadura";
	public static final String TAG_MODULE_ESCUDOS = "escudos";
	public static final String TAG_MODULE_RECARGA = "recarga";
	public static final String TAG_MODULE_ATAQUE = "ataque";
	public static final String TAG_MODULE_COSTE = "coste";


	
	JSONArray modules = null;

	ArrayList<HashMap<String, String>> modulesList;
	
	ListView listModules;
	
	JSONParser jsonParser = new JSONParser();
	BaseAdapter mAdapter;
	Bitmap bmpModule;
	ImageView imgModule;

	TextView tripulacion;
	TextView armadura;
	TextView escudos;
	TextView saldo;
	TextView valor;
	CustomTextView ctbModuleInfo ;
	CustomTextView ctbModulePicture;
	
	TextView txtTripulacion;
	TextView txtDescripcion;
	TextView txtTech;
	TextView txtCarga;
	TextView txtMotor;
	TextView txtArmadura;
	TextView txtEscudo;
	TextView txtRecarga;
	TextView txtCoste;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		try {
			
			
			super.onCreate(savedInstanceState);
			setContentView(R.layout.activity_ship);
			
			this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
			
			tripulacion = (TextView) findViewById(R.id.txtTripulacion) ;
			armadura = (TextView) findViewById(R.id.txtArmadura) ;
			escudos = (TextView) findViewById(R.id.txtEscudos) ;
			saldo = (TextView) findViewById(R.id.txtSaldos) ;
			valor = (TextView) findViewById(R.id.txtValor) ;
			
			imgModule =(ImageView) findViewById (R.id.imgShip);
			
			modulesList = new ArrayList<HashMap<String, String>>();
			listModules = (ListView) findViewById(R.id.lstModules);
			listModules.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
				@Override
				public void onItemClick(AdapterView<?> arg0, View view,int position, long arg3) 
				{
					try 
					{
						String moduleName=((TextView) view.findViewById(R.id.txtModule )).getText().toString();
						String id_module = ((TextView) view.findViewById(R.id.txtModuleId )).getText().toString();
						LoadModules loadModule=new LoadModules();
						loadModule.execute(id_module);
						
						
						ctbModuleInfo.setText(moduleName.concat(" ").concat(getResources().getString(R.string.module_info)));
						ctbModulePicture.setText(moduleName.concat(" ").concat(getResources().getString(R.string.module_picture)));
						
					}
					catch (Exception ex)
					{
						ex.printStackTrace();
					}
				}
			});
			
			
			ctbModuleInfo = (CustomTextView) findViewById(R.id.ctbModuleInfo2);
			ctbModulePicture= (CustomTextView) findViewById(R.id.ctbModulePicure2);
			
			 txtTripulacion =(TextView) findViewById(R.id.txtCapTripulacion);
			 txtDescripcion =(TextView) findViewById(R.id.txtDescripcion);
			 txtTech =(TextView) findViewById(R.id.txtTech);
			 txtCarga =(TextView) findViewById(R.id.txtCarga);
			 txtMotor =(TextView) findViewById(R.id.txtMotor);
			 txtArmadura =(TextView) findViewById(R.id.txtArmaduraMod);
			 txtEscudo =(TextView) findViewById(R.id.txtEscudosMod);
			 txtRecarga =(TextView) findViewById(R.id.txtRecarga);
			 txtCoste =(TextView) findViewById(R.id.txtCoste);
		
			
			
			CustomButton btnHome = (CustomButton) findViewById(R.id.btnMainHome);		
	    	btnHome.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                      finish();
	                    }
	            });     
	    	
	    	LoadModules tarea = new LoadModules();
	    	tarea.execute();	    	

	    	LoadRankings tareaRanking = new LoadRankings();
	    	tareaRanking.execute();	    	

	    	
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	class LoadModules extends AsyncTask<String, String, String> {

		String login;
		String id_nave ;
		String id_modulo;
		String nombre;
		String descripcion;
		String tripulacion ;
		String tech  ;
		String carga ;
		String motor ;
		String armadura;
		String escudos ;
		String recarga ;
		String ataque  ;
		String coste  ;
		
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		}

		@Override
		protected String doInBackground(String... args) {
			HttpClient httpClient = new DefaultHttpClient();
			String respStr="";
			String json=""; 
			

			try {
				if (args.length>0) {
				try
				{
						HttpGet del = new HttpGet(Session.URL + "modules/module/" + args[0]);
				
						del.setHeader("content-type", "application/json");
					
			        	HttpResponse resp = httpClient.execute(del);
			        	respStr = EntityUtils.toString(resp.getEntity());
			        	
			        	JSONObject c = new JSONObject(respStr);
			        	
			        	
			        	//nombre= respJSON.getString(TAG_NOMBRE);
			        	
			        	URL url= new URL(Session.URL+ "img/modules/" + args[0] + ".jpg");
						bmpModule = BitmapFactory.decodeStream(url.openConnection().getInputStream());
				        json="OK";
				        
				        login= c.getString(TAG_MODULE_LOGIN);
						id_nave = String.valueOf((int)c.getDouble(TAG_MODULE_ID_NAVE));
						id_modulo = String.valueOf((int)c.getDouble(TAG_MODULE_ID_MODULO));
						nombre= c.getString(TAG_MODULE_NOMBRE);
						descripcion= c.getString(TAG_MODULE_DESCRIPCION);
						tripulacion = String.valueOf((int)c.getDouble(TAG_MODULE_TRIPULACION));
						tech  =String.valueOf((int)c.getDouble(TAG_MODULE_TECH));
						carga = String.valueOf((int)c.getDouble(TAG_MODULE_CARGA));
						motor = String.valueOf((int)c.getDouble(TAG_MODULE_MOTOR));
						armadura=  String.valueOf((int)c.getDouble(TAG_MODULE_ARMADURA));
						escudos = String.valueOf((int)c.getDouble(TAG_MODULE_ESCUDOS));
						recarga  =String.valueOf((int)c.getDouble(TAG_MODULE_RECARGA));
						ataque  =String.valueOf((int)c.getDouble(TAG_MODULE_ATAQUE));
						coste  =String.valueOf((int)c.getDouble(TAG_MODULE_COSTE));

				        
			        }
			        catch(Exception ex)
			        {
			        	Log.e("ServicioRest","Error!", ex);
			        	
			        	json = "KO";
			        }
					
		    	}
				else {
					List<NameValuePair> params = new ArrayList<NameValuePair>();
		
					// getting JSON string from URL
					json = jsonParser.makeHttpRequest(Session.URL + "modules/modules/" + Session.login, "GET",
							params);
		
					
					
					// Check your log cat for JSON reponse
					Log.d("Modules JSON: ", "> " + json);
				}

			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        	
			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				if (json!="OK" && json!="KO")
				{
					modules = new JSONArray(json);
					modulesList.clear();
					if (modules != null) {
						// looping through All albums
						for (int i = 0; i < modules.length(); i++) {
							JSONObject c = modules.getJSONObject(i);
	
							// Storing each json item values in variable
							login= c.getString(TAG_MODULE_LOGIN);
							id_nave = String.valueOf((int)c.getDouble(TAG_MODULE_ID_NAVE));
							id_modulo = String.valueOf((int)c.getDouble(TAG_MODULE_ID_MODULO));
							nombre= c.getString(TAG_MODULE_NOMBRE);
							descripcion= c.getString(TAG_MODULE_DESCRIPCION);
							tripulacion = String.valueOf((int)c.getDouble(TAG_MODULE_TRIPULACION));
							tech  =String.valueOf((int)c.getDouble(TAG_MODULE_TECH));
							carga = String.valueOf((int)c.getDouble(TAG_MODULE_CARGA));
							motor = String.valueOf((int)c.getDouble(TAG_MODULE_MOTOR));
							armadura=  String.valueOf((int)c.getDouble(TAG_MODULE_ARMADURA));
							escudos = String.valueOf((int)c.getDouble(TAG_MODULE_ESCUDOS));
							recarga  =String.valueOf((int)c.getDouble(TAG_MODULE_RECARGA));
							ataque  =String.valueOf((int)c.getDouble(TAG_MODULE_ATAQUE));
							coste  =String.valueOf((int)c.getDouble(TAG_MODULE_COSTE));


							
							// creating new HashMap
							HashMap<String, String> map = new HashMap<String, String>();
	
							// adding each child node to HashMap key => value
							map.put(TAG_MODULE_LOGIN, login);
							map.put(TAG_MODULE_ID_NAVE, id_nave);
							map.put(TAG_MODULE_ID_MODULO, id_modulo);
							map.put(TAG_MODULE_NOMBRE, nombre);
							map.put(TAG_MODULE_DESCRIPCION, descripcion);
							map.put(TAG_MODULE_TRIPULACION, tripulacion);
							map.put(TAG_MODULE_TECH, tech);
							map.put(TAG_MODULE_CARGA, carga);
							map.put(TAG_MODULE_MOTOR, motor);
							map.put(TAG_MODULE_ARMADURA, armadura);
							map.put(TAG_MODULE_ESCUDOS, escudos);
							map.put(TAG_MODULE_RECARGA, recarga);
							map.put(TAG_MODULE_ATAQUE, ataque);
							map.put(TAG_MODULE_COSTE, coste);

							
							// adding HashList to ArrayList
							modulesList.add(map);
						}
	
						mAdapter = new ModuleListAdapter(ShipActivity.this,
								modulesList);
						listModules.setAdapter(mAdapter);
						mAdapter.notifyDataSetChanged();
						
						// dismiss the dialog after getting all albums
						//pDialog.dismiss();
					} else {
						Log.d("Modules: ", "null");
					}
	
				} else 
				{
					if (json.equals("OK")) { 
						imgModule.setImageBitmap(bmpModule);
						
						 txtTripulacion.setText(tripulacion);
						 txtDescripcion.setText(descripcion);
						 txtTech.setText(tech);
						 txtCarga.setText(carga);
						 txtMotor.setText(motor);
						 txtArmadura.setText(armadura);
						 txtEscudo.setText(escudos);
						 txtRecarga.setText(recarga);
						 txtCoste.setText(coste);
					
						
					}
					else
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.social_not_existing_friend) , 
		        			   Toast.LENGTH_LONG).show();
					}
				}
			} catch (JSONException e) {
				e.printStackTrace();
			} catch (JsonParseException e) {
				e.printStackTrace();
			}
		}
	}


	class LoadRankings extends AsyncTask<String, String, String> {

		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			
		}

		@Override
		protected String doInBackground(String... args) {
			List<NameValuePair> params = new ArrayList<NameValuePair>();

			// getting JSON string from URL
			String json = jsonParser.makeHttpRequest(Session.URL + "ranking/ranking/" + Session.login , "GET",
					params);

			// Check your log cat for JSON reponse
			Log.d("Mails JSON: ", "> " + json);

			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				JSONObject c = new JSONObject(json);;

				tripulacion.setText(  String.valueOf((int)c.getDouble(SocialActivity.TAG_RANKING_TRIPULACION)));
				armadura.setText(String.valueOf((int)c.getDouble(SocialActivity.TAG_RANKING_ARMADURA)));
				escudos.setText(String.valueOf((int)c.getDouble(SocialActivity.TAG_RANKING_ESCUDO)));
				saldo.setText(String.valueOf((int)c.getDouble(SocialActivity.TAG_RANKING_SALDO)));
				valor.setText(String.valueOf((int)c.getDouble(SocialActivity.TAG_RANKING_VALOR)));

			} catch (JSONException e) {
				e.printStackTrace();
			} catch (JsonParseException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	
	}

	 
	
}
