package com.jmgv.themerchant;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import com.example.themerchant.R;
import com.google.gson.JsonParseException;
import com.jmgv.ui.Utils;
import com.jmgv.ui.CustomButton;
import android.app.Activity;
import android.app.ProgressDialog;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.os.Handler;


public class SocialActivity  extends Activity
{
	// Progress Dialog
	private ProgressDialog pDialog;

	//mails
	public static final String TAG_MAIL_SENDER = "Id_Usuario";
	public static final String TAG_MAIL_MESSAGE= "Mensaje";
	public static final String TAG_MAIL_DATE= "Fecha_Hora";
	//friends
	public static final String TAG_FRIEND_FRIEND= "Id_Amigo";
	//ranking
	public static final String TAG_RANKING_LOGIN= "Login";
	public static final String TAG_RANKING_ESCUDO= "Escudos";
	public static final String TAG_RANKING_TRIPULACION= "Tripulacion";
	public static final String TAG_RANKING_ARMADURA= "Armadura";
	public static final String TAG_RANKING_VALOR= "Valor";
	public static final String TAG_RANKING_SALDO="Saldo";
	
	
	//chats
	
	
	
	JSONArray mails = null;
	JSONArray friends = null;
	JSONArray ranking = null;
	JSONArray chats = null;
	
	ArrayList<HashMap<String, String>> friendList;
	ArrayList<HashMap<String, String>> mailList;
	ArrayList<HashMap<String, String>> rankingList;
	ArrayList<HashMap<String, String>> chatList;
	
	ListView listMail;
	ListView listFriend;
	ListView listRanking;
	ListView listChat;
	
	
	JSONParser jsonParser = new JSONParser();
	BaseAdapter mAdapter;
	
	String mailTarget="";
	CustomButton btnSendMail; 
	
	public void callAsynchronousTaskChat() {
	    final Handler handler = new Handler();
	    Timer timer = new Timer();
	    TimerTask doAsynchronousTask = new TimerTask() {       
	        @Override
	        public void run() {
	            handler.post(new Runnable() {
	                public void run() {       
	                    try {
	                    	if (Session.blnChat) {
	                    		new LoadChats().execute();
	                    		Session.blnChat=false;
	                    	}
	                    } catch (Exception e) {
	                        e.printStackTrace();
	                    }
	                }
	            });
	        }
	    };
	    timer.schedule(doAsynchronousTask, 0, 3000); //execute in every 50000 ms
	}
	
	public void callAsynchronousTaskMail() {
	    final Handler handler = new Handler();
	    Timer timer = new Timer();
	    TimerTask doAsynchronousTask = new TimerTask() {       
	        @Override
	        public void run() {
	            handler.post(new Runnable() {
	                public void run() {       
	                    try {
	                    	if (Session.blnMail ) {
	                    		new LoadMails().execute();
	                        	Session.blnMail=false;
	                    	}
	                    } catch (Exception e) {
	                        e.printStackTrace();
	                    }
	                }
	            });
	        }
	    };
	    timer.schedule(doAsynchronousTask, 0, 10000); //execute in every 50000 ms
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		try {
			
			
			super.onCreate(savedInstanceState);
			setContentView(R.layout.activity_social);
			
			this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
			
			CustomButton btnHome = (CustomButton) findViewById(R.id.btnMainHome);
		
	    	btnHome.setOnClickListener(new OnClickListener() {
	                    @Override
	                    public void onClick(View arg0) {
	                      finish();
	                    }
	            });     
		
	    	
	    	CustomButton btnAddChat = (CustomButton) findViewById(R.id.cbtAddChat);
	    	btnAddChat.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View arg0) {
                	EditText txtMessageChat =(EditText) findViewById(R.id.edtChatMessage); ; 
                	LoadChats tarea = new LoadChats();
    				tarea.execute(Session.login,txtMessageChat.getText().toString());
    				txtMessageChat.setText("");
                }
	    	});     

	    	btnSendMail = (CustomButton) findViewById(R.id.ctbSendMail );
	    	btnSendMail.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View arg0) {
                	EditText txtMessageMail =(EditText) findViewById(R.id.edtMail); ; 
                	LoadMails tarea = new LoadMails();
    				tarea.execute(Session.login, mailTarget, txtMessageMail.getText().toString());
    				txtMessageMail.setText("");
    				
                }
	    	});     

	    	CustomButton btnAddFriend = (CustomButton) findViewById(R.id.cbtFriend );
	    	btnAddFriend.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View arg0) {
                	EditText txtFriend =(EditText) findViewById(R.id.edtFriend ); ; 
                	LoadFriends tarea = new LoadFriends();
    				tarea.execute(Session.login,  txtFriend.getText().toString());
    				txtFriend.setText("");
                }
	    	});     
	    	
			
			// Hashmap for ListView
			mailList = new ArrayList<HashMap<String, String>>();
			friendList = new ArrayList<HashMap<String, String>>();
			rankingList = new ArrayList<HashMap<String, String>>();
			chatList = new ArrayList<HashMap<String, String>>();
			
			//Evento de click de listas
			listMail = (ListView) findViewById(R.id.lstMail);
			listMail.setDivider(null);
			listMail.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
				@Override
				public void onItemClick(AdapterView<?> arg0, View view,
						int position, long arg3) {
					
					//Toast.makeText(SocialActivity.this, "Item selected: " + position,Toast.LENGTH_LONG).show();
				
					/* Intent i = new Intent(getApplicationContext(),ItemListActivity.class);
					String category_id = ((TextView) view .findViewById(R.id.category_id)).getText().toString();
					i.putExtra("category_id", category_id);
					startActivity(i);*/
				}
			});
			
			
			listFriend = (ListView) findViewById(R.id.lstFriends );
			listFriend.setDivider(null);
			listFriend.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
				@Override
				public void onItemClick(AdapterView<?> arg0, View view,
						int position, long arg3) {
					
					try {
						
						mailTarget = (String) ((TextView) view.findViewById(R.id.txtFriend)).getText().toString();
						
						btnSendMail.setText(getResources().getString(R.string.social_mail) + " to " + mailTarget );
					}
					catch (Exception ex)
					{
						ex.printStackTrace();
					}
				}
			});
			
			listChat= (ListView) findViewById(R.id.lstChat );
			listChat.setDivider(null);
			listChat.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
				@Override
				public void onItemClick(AdapterView<?> arg0, View view,
						int position, long arg3) {
					
				}
			});
			
			listRanking= (ListView) findViewById(R.id.lstRanking);
			listRanking.setDivider(null);
			listRanking.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
				@Override
				public void onItemClick(AdapterView<?> arg0, View view,
						int position, long arg3) {
					
									}
			});
			
			
			
			//carga de listas
			new LoadChats().execute();
			new LoadMails().execute();
			new LoadFriends().execute();
			new LoadRankings().execute();

			callAsynchronousTaskChat();
			callAsynchronousTaskMail();
			//startTime = System.currentTimeMillis();
            //timerHandler.postDelayed(timerRunnable, 0);
			
			}
        catch(Exception ex)
        {
        	Log.e("ServicioRest","Error!", ex);
		}	
	
		
	}
	
	
	 @Override
	    public void onPause() {
	        super.onPause();
	        //timerHandler.removeCallbacks(timerRunnable);
	    }
	 
	 @Override
	 public void onResume() {
	     super.onResume();  // Always call the superclass method first
	     //timerHandler.postDelayed(timerRunnable, 0);
	 }
	
	class LoadMails extends AsyncTask<String, String, String> {
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			/*
			pDialog = new ProgressDialog(SocialActivity.this);
			pDialog.setMessage(getResources().getString(R.string.getting_mails));
			pDialog.setIndeterminate(false);
			pDialog.setCancelable(false);
			pDialog.show();
			*/
		}

		@Override
		protected String doInBackground(String... args) {

			String json; 
			if (args.length>0)
	    	{
		    	HttpClient httpClient = new DefaultHttpClient();
		        
				HttpPost post = new HttpPost(Session.URL + "mails/mail");
				post.setHeader("content-type", "application/json");
				
				try
		        {
					//Construimos el objeto cliente en formato JSON
					JSONObject dato = new JSONObject();
					
					//dato.put("Id", Integer.parseInt(txtId.getText().toString()));
					dato.put("Id_Usuario", args[0]);
					dato.put("Id_destinatario", args[1]);
					dato.put("Mensaje", args[2]);
					dato.put("Leido", false);
					
					StringEntity entity = new StringEntity(dato.toString());
					post.setEntity(entity);
					
		        	HttpResponse resp = httpClient.execute(post);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	
		        	//if(!respStr.equals("true"))
		        	//	resul = false;
		        	json = "OK";
		        }
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	json = "KO";
		        }
				
	    	}
			else {
					List<NameValuePair> params = new ArrayList<NameValuePair>();
		
					// getting JSON string from URL
					json = jsonParser.makeHttpRequest(Session.URL + "mails/mails/" + Session.login, "GET",
							params);
		
					// Check your log cat for JSON reponse
					Log.d("Mails JSON: ", "> " + json);
			}
			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				mails = new JSONArray(json);
				mailList.clear();
				
				if (mails != null) {
					// looping through All albums
					for (int i = 0; i < mails.length(); i++) {
						JSONObject c = mails.getJSONObject(i);

						// Storing each json item values in variable
						String sender= c.getString(TAG_MAIL_SENDER);
						String message = c.getString(TAG_MAIL_MESSAGE);
						String strDate = c.getString(TAG_MAIL_DATE);
						String date = Utils.getJSONDate(strDate,"dd/MM/yyyy hh:mm");

						// creating new HashMap
						HashMap<String, String> map = new HashMap<String, String>();

						// adding each child node to HashMap key => value
						map.put(TAG_MAIL_SENDER, sender);
						map.put(TAG_MAIL_MESSAGE, message);
						map.put(TAG_MAIL_DATE, date.toString());

						// adding HashList to ArrayList
						mailList.add(map);
					}

					mAdapter = new MailListAdapter(SocialActivity.this,
							mailList);
					listMail.setAdapter(mAdapter);
					mAdapter.notifyDataSetChanged();
					listMail.setSelection(listMail.getCount() - 1);
					
					// dismiss the dialog after getting all albums
					//pDialog.dismiss();
				} else if (json.equals("OK")) {
					
				}

			} catch (JSONException e) {
				e.printStackTrace();
			} catch (JsonParseException e) {
				e.printStackTrace();
			}catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	class LoadFriends extends AsyncTask<String, String, String> {
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		
			/*
			pDialog = new ProgressDialog(SocialActivity.this);
			pDialog.setMessage( getResources().getString(R.string.getting_friends ));
			pDialog.setIndeterminate(false);
			pDialog.setCancelable(false);
			pDialog.show();
			*/
		}

		@Override
		protected String doInBackground(String... args) {

			String json; 
			if (args.length>0)
	    	{
		    	HttpClient httpClient = new DefaultHttpClient();
		        
				HttpPost post = new HttpPost(Session.URL + "friends/friend");
				post.setHeader("content-type", "application/json");
				
				try
		        {
					//Construimos el objeto cliente en formato JSON
					JSONObject dato = new JSONObject();
					
					dato.put("Id_Usuario", args[0]);
					dato.put("Id_Amigo", args[1]);
					
					StringEntity entity = new StringEntity(dato.toString());
					post.setEntity(entity);
					
		        	HttpResponse resp = httpClient.execute(post);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	
		        	if(!respStr.equals("true"))
		        		json ="KO";
		        	else
		        		json = "OK";
		        	

		        }
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	
		        	json = "KO";
		        }
				
	    	}
			else {
				List<NameValuePair> params = new ArrayList<NameValuePair>();
	
				// getting JSON string from URL
				json = jsonParser.makeHttpRequest(Session.URL + "friends/friends/" + Session.login, "GET",
						params);
	
				// Check your log cat for JSON reponse
				Log.d("Mails JSON: ", "> " + json);
			}
			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				if (json!="OK" && json!="KO")
				{
					friends = new JSONArray(json);
					friendList.clear();
					if (friends != null) {
						// looping through All albums
						for (int i = 0; i < friends.length(); i++) {
							JSONObject c = friends.getJSONObject(i);
	
							// Storing each json item values in variable
							String friend= c.getString(TAG_FRIEND_FRIEND);
							
							// creating new HashMap
							HashMap<String, String> map = new HashMap<String, String>();
	
							// adding each child node to HashMap key => value
							map.put(TAG_FRIEND_FRIEND, friend);
							
							// adding HashList to ArrayList
							friendList.add(map);
						}
	
						mAdapter = new FriendListAdapter(SocialActivity.this,
								friendList);
						listFriend.setAdapter(mAdapter);
						mAdapter.notifyDataSetChanged();
						
						// dismiss the dialog after getting all albums
						//pDialog.dismiss();
					} else {
						Log.d("Friends: ", "null");
					}
	
				} else 
				{
					if (json.equals("OK")) { 
			        	LoadFriends tarea = new LoadFriends();
			        	tarea.execute();
					}
					else
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.social_not_existing_friend) , 
		        			   Toast.LENGTH_LONG).show();
					}
				}
			} catch (JSONException e) {
				e.printStackTrace();
				
			} catch (JsonParseException e) {
				e.printStackTrace();
				
			}
		}
	}

	class LoadChats extends AsyncTask<String, String, String> {
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		}

		@Override
		protected String doInBackground(String... args) {
			String json; 
			if (args.length>0)
	    	{
		    	HttpClient httpClient = new DefaultHttpClient();
		        
				HttpPost post = new HttpPost(Session.URL + "Chat/chat");
				post.setHeader("content-type", "application/json");
				
				try
		        {
					//Construimos el objeto cliente en formato JSON
					JSONObject dato = new JSONObject();
					
					//dato.put("Id", Integer.parseInt(txtId.getText().toString()));
					dato.put("Id_Usuario", args[0]);
					dato.put("Mensaje", args[1]);
					
					StringEntity entity = new StringEntity(dato.toString());
					post.setEntity(entity);
					
		        	HttpResponse resp = httpClient.execute(post);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	
		        	//if(!respStr.equals("true"))
		        	//	resul = false;
		        	json = "OK";
		        }
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	json = "KO";
		        }
				
	    	}
				else {
					// Building Parameters
					List<NameValuePair> params = new ArrayList<NameValuePair>();
		
					// getting JSON string from URL
					json = jsonParser.makeHttpRequest(Session.URL + "chat/chats", "GET",
							params);
		
					// Check your log cat for JSON reponse
					Log.d("Mails JSON: ", "> " + json);
				}
			return json;			
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				if (json!="OK" && json!="KO")
				{
					chats = new JSONArray(json);
					chatList.clear();
					
					if (chats != null) {
						// looping through All albums
						for (int i = 0; i < chats.length(); i++) {
							JSONObject c = chats.getJSONObject(i);
	
							// Storing each json item values in variable
							String sender= c.getString(TAG_MAIL_SENDER);
							String message= c.getString(TAG_MAIL_MESSAGE);
							String strDate = c.getString(TAG_MAIL_DATE);
							String date = Utils.getJSONDate(strDate,"dd/MM/yyyy hh:mm");
							
							
							// creating new HashMap
							HashMap<String, String> map = new HashMap<String, String>();
	
							// adding each child node to HashMap key => value
							map.put(TAG_MAIL_SENDER, sender);
							map.put(TAG_MAIL_MESSAGE, message);
							map.put(TAG_MAIL_DATE, date.toString());
	
							// adding HashList to ArrayList
							chatList.add(map);
						}
						
						
						mAdapter = new ChatListAdapter(SocialActivity.this,
								chatList);
						listChat.setAdapter(mAdapter);
						mAdapter.notifyDataSetChanged();
						listChat.setSelection(listChat.getCount() - 1);
						// dismiss the dialog after getting all albums
						//pDialog.dismiss();
					} else {
						Log.d("Chats: ", "null");
					}
				} else if (json.equals("OK")){
					
				}
			} catch (JSONException e) {
				e.printStackTrace();
			} catch (JsonParseException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	class LoadRankings extends AsyncTask<String, String, String> {
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			/*
		 	pDialog = new ProgressDialog(SocialActivity.this);
			pDialog.setMessage( getResources().getString(R.string.getting_ranking));
			pDialog.setIndeterminate(false);
			pDialog.setCancelable(false);
			pDialog.show();
			*/
		}

		@Override
		protected String doInBackground(String... args) {
			// Building Parameters
			List<NameValuePair> params = new ArrayList<NameValuePair>();

			// getting JSON string from URL
			String json = jsonParser.makeHttpRequest(Session.URL + "ranking/rankings" , "GET",
					params);

			// Check your log cat for JSON reponse
			Log.d("Mails JSON: ", "> " + json);

			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				ranking = new JSONArray(json);

				if (ranking != null) {
					// looping through All albums
					for (int i = 0; i < ranking.length(); i++) {
						JSONObject c = ranking.getJSONObject(i);

						// Storing each json item values in variable
						
						String friend= c.getString(TAG_RANKING_LOGIN);
						String tripulacion=  String.valueOf((int)c.getDouble(TAG_RANKING_TRIPULACION));
						String armadura= String.valueOf((int)c.getDouble(TAG_RANKING_ARMADURA));
						String escudos= String.valueOf((int)c.getDouble(TAG_RANKING_ESCUDO));
						String saldo= String.valueOf((int)c.getDouble(TAG_RANKING_SALDO));
						String valor= String.valueOf((int)c.getDouble(TAG_RANKING_VALOR));
						
						
						
						// creating new HashMap
						HashMap<String, String> map = new HashMap<String, String>();

						// adding each child node to HashMap key => value
						map.put(TAG_RANKING_LOGIN, friend);
						map.put(TAG_RANKING_TRIPULACION, tripulacion);
						map.put(TAG_RANKING_ARMADURA, armadura);
						map.put(TAG_RANKING_ESCUDO, escudos);
						map.put(TAG_RANKING_SALDO, saldo);
						map.put(TAG_RANKING_VALOR, valor);
						
						// adding HashList to ArrayList
						rankingList.add(map);
					}

					mAdapter = new RankingListAdapter(SocialActivity.this,
							rankingList);
					listRanking.setAdapter(mAdapter);

					// dismiss the dialog after getting all albums
					pDialog.dismiss();
				} else {
					Log.d("Rankings: ", "null");
				}

			} catch (JSONException e) {
				e.printStackTrace();
			} catch (JsonParseException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	
	}

	 
}

