package com.jmgv.themerchant;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.example.themerchant.R;
import com.google.gson.JsonParseException;
import com.jmgv.ui.CustomButton;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Editable;
import android.text.InputType;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class TradeActivity extends Activity {
	
	public static final String TAG_CARGO_LOGIN = "login";
	public static final String TAG_CARGO_ID_PLANETA = "id_planeta";
	public static final String TAG_CARGO_PLANETA = "planeta";
	public static final String TAG_CARGO_CANTIDAD = "cantidad";
	public static final String TAG_CARGO_PRECIO_COMPRA = "precio_compra";
	public static final String TAG_CARGO_PRECIO_VENTA = "precio_venta";
	public static final String TAG_CARGO_VALOR_BASE = "valor_base";
	public static final String TAG_CARGO_MERCANCIA = "mercancia";
	public static final String TAG_CARGO_DESCRIPCION = "descripcion";
	public static final String TAG_CARGO_ID_MERCANCIA = "id_mercancia";
	public static final String TAG_CARGO_VENDIBLE = "vendible";

	
	JSONArray planets = null;
	JSONArray cargoUsers = null;
	JSONArray cargoPlanets = null;
	ArrayList<HashMap<String, String>> planetsList;
	ArrayList<HashMap<String, String>> cargoUsersList;
	ArrayList<HashMap<String, String>> cargoPlanetsList;
	ListView listPlanets;
	ListView listCargoUsers;
	ListView listCargoPlanets;
	JSONParser jsonParser = new JSONParser();
	BaseAdapter mAdapter;
	BaseAdapter mAdapterCargoUser;
	BaseAdapter mAdapterCargoPlanet;
	
	String planetTarget="";
	String planetTargetId="";
	String distancia="0";
	String materialId="";
	String materialIdBuy="";
	String materialIdSell="";
	String material="";
	
	CustomButton btnNavigate; 	
	CustomButton btnBuy; 	
	CustomButton btnSell; 	
	Context mContext;
	
	@Override
		protected void onCreate(Bundle savedInstanceState) {
			try {
				
				
				super.onCreate(savedInstanceState);
				setContentView(R.layout.activity_trade);
				
				mContext = this;
				
				this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
				
				CustomButton btnHome = (CustomButton) findViewById(R.id.btnMainHome);
		    	btnHome.setOnClickListener(new OnClickListener() {
		                    @Override
		                    public void onClick(View arg0) {
		                      finish();
		                    }
		            });     
		    	
		    	btnNavigate = (CustomButton) findViewById(R.id.cbtNavigateTrade );
				btnNavigate.setOnClickListener(new OnClickListener() {
		                    @Override
		                    public void onClick(View arg0) {
		                    	if (planetTarget!="") {
		                    	new LoadPlanets().execute(Session.login,planetTargetId,distancia);
		                    	
		                    }
		                }
		            });     
				
				
				planetsList = new ArrayList<HashMap<String, String>>();
				cargoUsersList = new ArrayList<HashMap<String, String>>();
				cargoPlanetsList = new ArrayList<HashMap<String, String>>();
				
				
		    	listPlanets = (ListView) findViewById(R.id.lstPlanetTrade);
				listPlanets.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
					@Override
					public void onItemClick(AdapterView<?> arg0, View view,
							int position, long arg3) {
						
						try {
							
							planetTarget = (String) ((TextView) view.findViewById(R.id.txtPlanet )).getText().toString();
							planetTargetId = (String) ((TextView) view.findViewById(R.id.txtPlanetId )).getText().toString();
							distancia=(String) ((TextView) view.findViewById(R.id.txtDist)).getText().toString();
							btnNavigate.setText(getResources().getString(R.string.go) + " to " + planetTarget );
						}
						catch (Exception ex)
						{
							ex.printStackTrace();
						}
					}
				});
		    	
				
				
				listCargoUsers= (ListView) findViewById(R.id.lstCargo);
				listCargoUsers.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
					@Override
					public void onItemClick(AdapterView<?> arg0, View view,
							int position, long arg3) {
						
						try {
							String vendible=(String) ((TextView) view.findViewById(R.id.txtMercVendible)).getText().toString();
							if (vendible.equals("true")) {
								materialIdSell=(String) ((TextView) view.findViewById(R.id.txtMercID)).getText().toString();
								planetTargetId = (String) ((TextView) view.findViewById(R.id.txtMercIDPlanet  )).getText().toString();
								material=(String) ((TextView) view.findViewById(R.id.txtMercMercancia)).getText().toString();
								btnSell.setText(getResources().getString(R.string.trade_sell ) + " " + material );
							}	
							else
							{
								Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.not_sellable) , 
					        			   Toast.LENGTH_LONG).show();
							}
								
						}
						catch (Exception ex)
						{
							ex.printStackTrace();
						}
					}
				});
				
				
				listCargoPlanets = (ListView) findViewById(R.id.lstCargoPlanet);
				listCargoPlanets.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {
					@Override
					public void onItemClick(AdapterView<?> arg0, View view,
							int position, long arg3) {
						try {
							
							materialIdBuy=(String) ((TextView) view.findViewById(R.id.txtBuyID)).getText().toString();
							planetTargetId = (String) ((TextView) view.findViewById(R.id.txtMercIDPlanet  )).getText().toString();
							material=(String) ((TextView) view.findViewById(R.id.txtMercMercancia)).getText().toString();
							btnBuy.setText(getResources().getString(R.string.trade_buy ) + " " + material );
						}
						catch (Exception ex)
						{
							ex.printStackTrace();
						}
					}
				});

				
				btnBuy = (CustomButton) findViewById(R.id.cbtBuy);
				btnBuy.setOnClickListener(new OnClickListener() {
		                    @Override
		                    public void onClick(View arg0) {
		                    	final EditText input = new EditText(mContext);
		                    	input.setInputType(InputType.TYPE_CLASS_NUMBER);
		                    	new AlertDialog.Builder(mContext)
		                        .setTitle("Buying quantity")
		                        .setMessage("Enter quantity")
		                        .setView(input)
		                        .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
		                            public void onClick(DialogInterface dialog, int whichButton) {
		                                Editable value = input.getText(); 
		                                new LoadCargos().execute("BUY",materialIdBuy,value.toString(),planetTargetId);         
		                            }
		                        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
		                            public void onClick(DialogInterface dialog, int whichButton) {
		                                // Do nothing.
		                            }
		                        }).show();
		                    }
		                
		            	});     
				
				
				btnSell = (CustomButton) findViewById(R.id.cbtSell  );
				btnSell.setOnClickListener(new OnClickListener() {
		                    @Override
		                    public void onClick(View arg0) {
		                    	
		                    	final EditText input = new EditText(mContext);
		                    	input.setInputType(InputType.TYPE_CLASS_NUMBER);
		                    	new AlertDialog.Builder(mContext)
		                        .setTitle("Selling quantity")
		                        .setMessage("Enter quantity")
		                        .setView(input)
		                        .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
		                            public void onClick(DialogInterface dialog, int whichButton) {
		                                Editable value = input.getText(); 
		                                new LoadCargos().execute("SELL",materialIdSell,value.toString(),planetTargetId);
		                            }
		                        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
		                            public void onClick(DialogInterface dialog, int whichButton) {
		                                // Do nothing.
		                            }
		                        }).show();
		                    }
		            	});     
				
				
				new LoadPlanets().execute();
				new LoadCargos().execute("CARGOUSERS");
				new LoadCargos().execute("CARGOPLANETS");
		    	
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	
	class LoadPlanets extends AsyncTask<String, String, String> {
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		}

		@Override
		protected String doInBackground(String... args) {

			String json; 
			if (args.length>0)
	    	{
		    	HttpClient httpClient = new DefaultHttpClient();
		        
				HttpPut put = new HttpPut(Session.URL + "planetas/planeta");
				put.setHeader("content-type", "application/json");
				
				try
		        {
					//Construimos el objeto cliente en formato JSON
					JSONObject dato = new JSONObject();
					
					dato.put("login", args[0]);
					dato.put("id_planeta", Double.parseDouble(args[1]));
					dato.put("distancia", Double.parseDouble(args[2]));
					
					StringEntity entity = new StringEntity(dato.toString());
					put.setEntity(entity);
					
		        	HttpResponse resp = httpClient.execute(put);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	
		        	if(!respStr.equals("true"))
		        		json ="KO";
		        	else
		        		json = "OK";
		        	

		        }
		        catch(Exception ex)
		        {
		        	Log.e("ServicioRest","Error!", ex);
		        	
		        	json = "KO";
		        }
				
	    	}
			else {
				List<NameValuePair> params = new ArrayList<NameValuePair>();
	
				// getting JSON string from URL
				json = jsonParser.makeHttpRequest(Session.URL + "planetas/planetas/" + Session.login, "GET",
						params);
	
				// Check your log cat for JSON reponse
				Log.d("Mails JSON: ", "> " + json);
			}
			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				if (json!="OK" && json!="KO")
				{
					planets = new JSONArray(json);
					planetsList.clear();
					if (planets != null) {
						// looping through All albums
						for (int i = 0; i < planets.length(); i++) {
							JSONObject c = planets.getJSONObject(i);
	
							// Storing each json item values in variable
							
							
							// creating new HashMap
							HashMap<String, String> map = new HashMap<String, String>();

							map.put(NavigateActivity.TAG_LOGIN,c.getString(NavigateActivity.TAG_LOGIN).toString());
							map.put(NavigateActivity.TAG_PLANET,c.getString(NavigateActivity.TAG_PLANET));
							map.put(NavigateActivity.TAG_PLANET_ID,String.valueOf((int)c.getDouble(NavigateActivity.TAG_PLANET_ID)));							
							map.put(NavigateActivity.TAG_DIST ,String.valueOf((int)c.getDouble(NavigateActivity.TAG_DIST)));
							map.put(NavigateActivity.TAG_CLIMA ,c.getString(NavigateActivity.TAG_CLIMA));
							map.put(NavigateActivity.TAG_REL ,c.getString(NavigateActivity.TAG_REL));
							map.put(NavigateActivity.TAG_EST ,String.valueOf((int)c.getDouble(NavigateActivity.TAG_EST)));
							map.put(NavigateActivity.TAG_TECH ,String.valueOf((int)c.getDouble(NavigateActivity.TAG_TECH)));
							map.put(NavigateActivity.TAG_GOV ,c.getString(NavigateActivity.TAG_GOV));
							
							// adding HashList to ArrayList
							planetsList.add(map);
						}
	
						mAdapter = new PlanetListAdapter(TradeActivity.this,
								planetsList,true);
						listPlanets.setAdapter(mAdapter);
						mAdapter.notifyDataSetChanged();
						
						// dismiss the dialog after getting all albums
						//pDialog.dismiss();
					} else {
						Log.d("Planets: ", "null");
					}
				} else 
				{
					if (json.equals("OK")) { 
						Session.blnNavigating=true;
						finish();
					}
					else
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.planet_error) , 
		        			   Toast.LENGTH_LONG).show();
					}
				}
			} catch (JSONException e) {
				e.printStackTrace();
			} catch (JsonParseException e) {
				e.printStackTrace();
			}
		}
	}

	
	class LoadCargos extends AsyncTask<String, String, String> {
		String accion="";
		String idMaterial="";
		String cantidad="";
		String idPlaneta="";
		
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		}

		@Override
		protected String doInBackground(String... args) {
			accion=args[0];
			String json="4"; 
			
			if (accion.equals("CARGOUSERS"))
			{
				List<NameValuePair> params = new ArrayList<NameValuePair>();
				
				// getting JSON string from URL
				json = jsonParser.makeHttpRequest(Session.URL + "cargousuario/cargos/" + Session.login, "GET",
						params);
	
				// Check your log cat for JSON reponse
				Log.d("Mails JSON: ", "> " + json);
			}
			else if (accion.equals("CARGOPLANETS"))
			{
				List<NameValuePair> params = new ArrayList<NameValuePair>();
				
				// getting JSON string from URL
				json = jsonParser.makeHttpRequest(Session.URL + "cargoplaneta/cargos/" + Session.login, "GET",
						params);
	
				// Check your log cat for JSON reponse
				Log.d("Mails JSON: ", "> " + json);
			}
			else if (accion=="BUY")
			{
				idMaterial=args[1];
				cantidad=args[2];
				idPlaneta=args[3];
				
				HttpClient httpClient = new DefaultHttpClient();
		        
				HttpPost post = new HttpPost(Session.URL + "cargoplaneta/cargo");
				post.setHeader("content-type", "application/json");
				
		
				//Construimos el objeto cliente en formato JSON
				JSONObject dato = new JSONObject();
				
				//dato.put("Id", Integer.parseInt(txtId.getText().toString()));
				try {
					dato.put("login", Session.login);
					dato.put("id_mercancia", idMaterial);
					dato.put("cantidad", cantidad);
					dato.put("id_planeta", idPlaneta);
					
					StringEntity entity = new StringEntity(dato.toString());
					post.setEntity(entity);
					
		        	HttpResponse resp = httpClient.execute(post);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	json=respStr;
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClientProtocolException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			else if (accion=="SELL")
			{
				idMaterial=args[1];
				cantidad=args[2];
				idPlaneta=args[3];
				
				HttpClient httpClient = new DefaultHttpClient();
		        
				HttpPost post = new HttpPost(Session.URL + "cargousuario/cargo");
				post.setHeader("content-type", "application/json");
				
		
				//Construimos el objeto cliente en formato JSON
				JSONObject dato = new JSONObject();
				
				//dato.put("Id", Integer.parseInt(txtId.getText().toString()));
				try {
					dato.put("login", Session.login);
					dato.put("id_mercancia", idMaterial);
					dato.put("cantidad", cantidad);
					dato.put("id_planeta", idPlaneta);
					
					StringEntity entity = new StringEntity(dato.toString());
					post.setEntity(entity);
					
		        	HttpResponse resp = httpClient.execute(post);
		        	String respStr = EntityUtils.toString(resp.getEntity());
		        	json=respStr;
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClientProtocolException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return json;
		}

		@Override
		protected void onPostExecute(String json) {
			try {
				if (accion=="CARGOUSERS"){
					cargoUsers = new JSONArray(json);
					cargoUsersList.clear();
					
					HashMap<String, String> map = new HashMap<String, String>();
					
					map.put(TAG_CARGO_LOGIN, Session.login);
					map.put(TAG_CARGO_CANTIDAD, "Qty.");
					map.put(TAG_CARGO_ID_MERCANCIA, "");
					map.put(TAG_CARGO_MERCANCIA, "Mat.");
					map.put(TAG_CARGO_VALOR_BASE, "Price");
					map.put(TAG_CARGO_DESCRIPCION, "Desc");
					map.put(TAG_CARGO_ID_PLANETA, "-1");
					map.put(TAG_CARGO_PLANETA, "");
					map.put(TAG_CARGO_VENDIBLE, "");

					
					// adding HashList to ArrayList
					cargoUsersList.add(map);
					
					if (cargoUsers != null) {
						// looping through All albums
						for (int i = 0; i < cargoUsers.length(); i++) {
							JSONObject c = cargoUsers.getJSONObject(i);
							
							// creating new HashMap
							 map = new HashMap<String, String>();

							String login= c.getString(TAG_CARGO_LOGIN);
							String cantidad= String.valueOf((int)c.getDouble(TAG_CARGO_CANTIDAD));
							String id_mercancia= String.valueOf((int)c.getDouble(TAG_CARGO_ID_MERCANCIA));
							String mercancia= c.getString(TAG_CARGO_MERCANCIA);
							String valor_base= String.valueOf((int)c.getDouble(TAG_CARGO_VALOR_BASE));
							String descripcion= c.getString(TAG_CARGO_DESCRIPCION);
							String id_planeta= String.valueOf((int)c.getDouble(TAG_CARGO_ID_PLANETA));
							String planeta= c.getString(TAG_CARGO_PLANETA);
							String vendible= String.valueOf((boolean)c.getBoolean(TAG_CARGO_VENDIBLE));

							map.put(TAG_CARGO_LOGIN, login);
							map.put(TAG_CARGO_CANTIDAD, cantidad);
							map.put(TAG_CARGO_ID_MERCANCIA, id_mercancia);
							map.put(TAG_CARGO_MERCANCIA, mercancia);
							map.put(TAG_CARGO_VALOR_BASE, valor_base);
							map.put(TAG_CARGO_DESCRIPCION, descripcion);
							map.put(TAG_CARGO_ID_PLANETA, id_planeta);
							map.put(TAG_CARGO_PLANETA, planeta);
							map.put(TAG_CARGO_VENDIBLE, vendible);

							
							// adding HashList to ArrayList
							cargoUsersList.add(map);
						}

						try
						{
							mAdapterCargoUser = new CargoUserListAdapter(TradeActivity.this,
									cargoUsersList);
							listCargoUsers.setAdapter(mAdapterCargoUser);
							mAdapterCargoUser.notifyDataSetChanged();
						}
						catch (Exception ex)
						{
							ex.printStackTrace();
						}
					
										
						
						} else {
							Log.d("Cargo Users: ", "null");
						}
						
				} else if (accion=="CARGOPLANETS")
					{
					cargoPlanets = new JSONArray(json);
					cargoPlanetsList.clear();
					
					HashMap<String, String> map = new HashMap<String, String>();

					map.put(TAG_CARGO_LOGIN, Session.login);
					map.put(TAG_CARGO_ID_PLANETA, "-1");
					map.put(TAG_CARGO_PLANETA, "");
					map.put(TAG_CARGO_CANTIDAD, "Qty");
					map.put(TAG_CARGO_PRECIO_COMPRA, "Sell");
					map.put(TAG_CARGO_PRECIO_VENTA, "Buy");
					map.put(TAG_CARGO_VALOR_BASE, "Base");
					map.put(TAG_CARGO_MERCANCIA, "Mat.");
					map.put(TAG_CARGO_DESCRIPCION, "");
					
					cargoPlanetsList.add(map);
					
					if (cargoPlanets != null) {
						// looping through All albums
						for (int i = 0; i < cargoPlanets.length(); i++) {
							JSONObject c = cargoPlanets.getJSONObject(i);
							
							// creating new HashMap
							map = new HashMap<String, String>();

							
							String login  =c.getString(TAG_CARGO_LOGIN);
							String id_planeta  =String.valueOf((int)c.getDouble(TAG_CARGO_ID_PLANETA));
							String planeta  =c.getString(TAG_CARGO_PLANETA);
							String cantidad  =String.valueOf((int)c.getDouble(TAG_CARGO_CANTIDAD));
							String precio_compra  =String.valueOf((int)c.getDouble(TAG_CARGO_PRECIO_COMPRA));
							String precio_venta  =String.valueOf((int)c.getDouble(TAG_CARGO_PRECIO_VENTA));
							String valor_base  =String.valueOf((int)c.getDouble(TAG_CARGO_VALOR_BASE));
							String mercancia  =c.getString(TAG_CARGO_MERCANCIA);
							String descripcion  =c.getString(TAG_CARGO_DESCRIPCION);
							String id_mercancia =String.valueOf((int)c.getDouble(TAG_CARGO_ID_MERCANCIA));
							
							
							map.put(TAG_CARGO_LOGIN, login);
							map.put(TAG_CARGO_ID_PLANETA, id_planeta);
							map.put(TAG_CARGO_PLANETA, planeta);
							map.put(TAG_CARGO_CANTIDAD, cantidad);
							map.put(TAG_CARGO_PRECIO_COMPRA, precio_compra);
							map.put(TAG_CARGO_PRECIO_VENTA, precio_venta);
							map.put(TAG_CARGO_VALOR_BASE, valor_base);
							map.put(TAG_CARGO_MERCANCIA, mercancia);
							map.put(TAG_CARGO_DESCRIPCION, descripcion);
							map.put(TAG_CARGO_ID_MERCANCIA, id_mercancia);
							
							// adding HashList to ArrayList
							cargoPlanetsList.add(map);
						}
	
						mAdapterCargoPlanet = new CargoPlanetListAdapter(TradeActivity.this,
								cargoPlanetsList);
						listCargoPlanets.setAdapter(mAdapterCargoPlanet);
						mAdapterCargoPlanet.notifyDataSetChanged();
					}
				} else if (accion=="BUY" || accion=="SELL")
				{
					if (json.equals("1")){
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.purchase_ok) , 
			        			   Toast.LENGTH_LONG).show();
						
						new LoadCargos().execute("CARGOUSERS");
						new LoadCargos().execute("CARGOPLANETS");
					}
					else if (json.equals("2"))
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.purchase_KO2) , 
			        			   Toast.LENGTH_LONG).show();
					}
					else if (json.equals("3"))
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.purchase_KO3) , 
			        			   Toast.LENGTH_LONG).show();
					}
					else if (json.equals("4"))
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.purchase_KO4) , 
			        			   Toast.LENGTH_LONG).show();
					}
					else if (json.equals("5"))
					{
						Toast.makeText(getApplicationContext(), (String)getResources().getString(R.string.purchase_KO5) , 
			        			   Toast.LENGTH_LONG).show();
					}
			
				}
			} catch (JSONException e) {
				e.printStackTrace();
				
			} catch (JsonParseException e) {
				e.printStackTrace();
			} 
		}
	}
	
	}
